> For the complete documentation index, see [llms.txt](https://docs-old.telematicssdk.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs-old.telematicssdk.com/sdk-installation/ios-sdk-intallation/incoming-tags.md).

# \*Incoming Tags

### Added incoming tags

You can set tags to Incoming then all tracks received after installing TAGS will be marked with these tags. Here the binding is done on a person (deviceToken). You can add, remove, and get a list of installed tags on IncomingTags for enriched trips these are the same tags as on Incoming but already linked to a specific track. You can also delete, add, and get Tags already linked to a specific track.

* (**void**)addFutureTrackTag:(RPTag \*)tag completion:(RPAPIITagCallback)callback;
* (**void**)removeFutureTrackTag:(RPTag \*)tag completion:(RPAPIITagCallback)callback;
* (**void**)getFutureTrackTag:(NSInteger)timestamp completion:(RPAPIITagGCallback)callback;
* (**void**)removeAllFutureTrackTagsWithСompletion:(RPAPIITagWCallback)callback;

addFutureTrackTag example

1. with out completion:\
   \[\[RPEntry instance].api addFutureTrackTag:tag completion:nil];
2. with completion:\
   \[\[RPEntry instance].api addFutureTrackTag:tag completion:^(RPTagStatus status, RPTag \*tag, NSInteger timestamp) {}];

**Usage example:**

```
[[RPEntry instance].api addFutureTrackTag:tag completion:nil];
[[RPEntry instance].api addFutureTrackTag:tag completion:^(RPTagStatus status, RPTag *tag, NSInteger timestamp) {}];
[[RPEntry instance].api getFutureTrackTag:0 completion:^(RPTagStatus status, NSArray<RPTag *> *tags, NSInteger timestamp) {
    for (RPTag *item in tags) {
        NSLog(@"%@", item.tag);
    }
}];
[[RPEntry instance].api removeFutureTrackTag:tag completion:^(RPTagStatus status, RPTag *tag, NSInteger timestamp) {}];
[[RPEntry instance].api removeAllFutureTrackTagsWithСompletion:^(RPTagStatus status, NSInteger timestamp) {}];
```

Added new RPTagsServerStateDelegate for online and offline operation status logging\
RPTagStatus in this protocol

```
typedef NS_ENUM(NSUInteger, RPTagStatus) {
    SUCCESS, // success for add or delete
    OFFLINE, // app in offline and operation saved in local database
    ERROR_WRONG_TIME, // operation canceled by server with wrong time(time from future)
    ERROR_TAG_OPERATION // operation canceled by server as duplicated or incorrect
};
```

**Usage example:**

```
@interface MyListener () <RPTagsServerStateDelegate> {}
@end

@implementation MyListener

- (instancetype)init {
    self = [super init];
    if (self) {
        [RPEntry instance].tagStateDelegate = self;
    }
    return self;
}

- (void)addTag:(RPTagStatus)status tag:(RPTag *)tag timestamp:(NSInteger)timestamp {
    NSString *str = @"";
    switch (status) {
        case SUCCESS:
            str = @"success for add or delete";
            break;
            
        case OFFLINE:
            str = @"app in offline and operation saved in local database";
            break;
                  
        case ERROR_WRONG_TIME:
            str = @"operation canceled by server with wrong time(time from future)";
            break;
            
        case ERROR_TAG_OPERATION:
            str = @"operation canceled by server as duplicated or incorrect";
            break;
            
        default:
            break;
    }
    NSLog(@"%@ - %@ - %ld", str, tag.toJSON, timestamp);
}

- (void)deleteTag:(RPTagStatus)status tag:(RPTag *)tag timestamp:(NSInteger)timestamp {
    NSString *str = @"";
    switch (status) {
        case SUCCESS:
            str = @"success for add or delete";
            break;
            
        case OFFLINE:
            str = @"app in offline and operation saved in local database";
            break;
                  
        case ERROR_WRONG_TIME:
            str = @"operation canceled by server with wrong time(time from future)";
            break;
            
        case ERROR_TAG_OPERATION:
            str = @"operation canceled by server as duplicated or incorrect";
            break;
            
        default:
            break;
    }
    NSLog(@"%@ - %@ - %ld", str, tag.toJSON, timestamp);
}

- (void)getTags:(RPTagStatus)status tags:(id)tags timestamp:(NSInteger)timestamp {
    NSString *str = @"";
    switch (status) {
        case SUCCESS:
            str = @"success for add or delete";
            break;
            
        case OFFLINE:
            str = @"app in offline and operation saved in local database";
            break;
                  
        case ERROR_WRONG_TIME:
            str = @"operation canceled by server with wrong time(time from future)";
            break;
            
        case ERROR_TAG_OPERATION:
            str = @"operation canceled by server as duplicated or incorrect";
            break;
            
        default:
            break;
    }
    NSLog(@"%@ - %@ - %ld", str, tags, timestamp);
}

- (void)removeAll:(RPTagStatus)status timestamp:(NSInteger)timestamp {
    NSString *str = @"";
    switch (status) {
        case SUCCESS:
            str = @"success for add or delete";
            break;
            
        case OFFLINE:
            str = @"app in offline and operation saved in local database";
            break;
                  
        case ERROR_WRONG_TIME:
            str = @"operation canceled by server with wrong time(time from future)";
            break;
            
        case ERROR_TAG_OPERATION:
            str = @"operation canceled by server as duplicated or incorrect";
            break;
            
        default:
            break;
    }
    NSLog(@"%@ - %ld", str, timestamp);
}

@end
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs-old.telematicssdk.com/sdk-installation/ios-sdk-intallation/incoming-tags.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
